Attribute VB_Name = "ZAcq"
Option Explicit
'POSITION INCREASES GOING DOWN
Global NumPlanes As Long
Global StepSize As Double
Global ZTop As Double, ZBot As Double
Global Const UNDEF = 77777
Global Const sErr = "Error"
Global FTool As Object

Global ahndl 'handle of capture application
Global CaptureDelay As Long 'IN SEC.

Function UpdateStepSize() As Integer
   If ((ZTop = UNDEF) Or (ZBot = UNDEF) Or (ZTop = ZBot) Or (NumPlanes <= 0)) Then
      UpdateStepSize = -1
   Else
      StepSize = Abs(ZBot - ZTop) / (NumPlanes - 1)
      UpdateStepSize = 1
   End If
End Function

Function UpdateNumPlanes() As Integer
   If ((ZTop = UNDEF) Or (ZBot = UNDEF) Or (ZTop = ZBot) Or (StepSize <= 0)) Then
      UpdateNumPlanes = -1
   Else
      NumPlanes = Abs(ZBot - ZTop) / StepSize + 1
      UpdateNumPlanes = 1
   End If
End Function

Function ReconcileParameters() As Integer
   Dim w As Double
   'ENSURE TOP IS ABOVE BOTTOM
   If ((ZTop = UNDEF) Or (ZBot = UNDEF) Or (ZTop = ZBot)) Then ReconcileParameters = -1: Exit Function
   If ((StepSize = UNDEF) Or (StepSize <= 0)) Then ReconcileParameters = -1: Exit Function
   If ((NumPlanes = UNDEF) Or (NumPlanes <= 0)) Then ReconcileParameters = -1: Exit Function
   If (ZTop > ZBot) Then
      w = ZTop: ZTop = ZBot: ZBot = w 'SWAP
      Call DisplayValues
   End If
   'DELAY
   On Error GoTo Err
   CaptureDelay = CLng(frmZStackAcq.txtDelay.Text)
   ReconcileParameters = 1
   Exit Function
Err:
   ReconcileParameters = -1
End Function

Sub DisplayValues()
   If (ZTop <> UNDEF) Then frmZStackAcq.lblTop.Caption = Format(ZTop, "0.00")
   If (ZBot <> UNDEF) Then frmZStackAcq.lblBot.Caption = Format(ZBot, "0.00")
   If (NumPlanes <> UNDEF) Then frmZStackAcq.txtNumPlanes = Format(NumPlanes, "0")
   If (StepSize <> UNDEF) Then frmZStackAcq.txtStepSize = Format(StepSize, "0.00")
   frmZStackAcq.lblMsg.Caption = "ZTop= " & Format(ZTop, "0.00") & ", ZBottom= " & Format(ZBot, "0.00") & ", ZHeight= " & Format(Abs(ZBot - ZTop), "0.00")
End Sub

Function AcquireZStack() As Integer
   Dim target As Double, stepcmd As String, i As Integer, spos As String
   'VERIFY DATA
   If (ReconcileParameters() < 0) Then
      frmZStackAcq.lblMsg.Caption = sErr: AcquireZStack = -1: Exit Function
   End If
   DoEvents
   'MOVE TO BELOW THE BOTTOM OF Z STACK THEN STEP UP AND ACQUIRE
   target = ZBot + StepSize
   FTool.Exec ("Z " & Format(target, "0.0000") & " ; Z Wait ;")
   frmZStackAcq.lblMsg.Caption = "Z= " & Format(target, "0.00")
   stepcmd = "Z Rel " & Format(-StepSize, "0.0000") & " ; Z Wait ;"
   For i = 1 To NumPlanes
      'STEP, WAIT AND READ POSITION
      FTool.Exec (stepcmd)
      spos = FTool.Exec("Z ?")
      frmZStackAcq.lblMsg.Caption = "#" & Str$(i) & " Z = " & spos
      DoEvents
      'ACQUIRE
      Call CaptureImage
      Call Delay(CaptureDelay * 1000)
   Next
   AcquireZStack = 1
End Function

Function Give1stWord(str0 As String, wrd As String) As Integer
   'FORMS FIRST WORD OF str0 IN wrd AND REMAINDER OF str0 IN str0
   'RETURNS LENGTH OF THE FIRST WORD. 0 - NO WORD
   Dim s As String, bpos As Long
   s = Trim(str0) & " "
   bpos = InStr(s, " ") - 1
   wrd = Left$(s, bpos)
   str0 = Trim(Right$(s, Len(s) - bpos))
   Give1stWord = bpos
End Function

Function CaptureImage() As Integer
   If (ahndl = 0) Then Exit Function
   AppActivate ahndl
'   SendKeys "^V", True
   SendKeys " ", True
End Function
